import { Global, Module } from '@nestjs/common';
import { HelperHashService } from './services';
import { SpacePermissionService } from './services/space.permission.service';
import { SpaceRepository } from '../modules/space/repositories';
import { SpaceRepositoryModule } from '../modules/space/space.repository.module';
import { TuyaWebSocketService } from './services/tuya.web.socket.service';

import { OneSignalService } from './services/onesignal.service';
import { DeviceMessagesService } from './services/device.messages.service';
import { DeviceRepositoryModule } from '../modules/device/device.repository.module';
import { DeviceNotificationRepository } from '../modules/device/repositories';
import { DeviceStatusFirebaseModule } from '../firebase/devices-status/devices-status.module';
import { CommunityPermissionService } from './services/community.permission.service';
import { CommunityRepository } from '../modules/community/repositories';
import { SosHandlerService } from './services/sos.handler.service';

@Global()
@Module({
  providers: [
    HelperHashService,
    SpacePermissionService,
    CommunityPermissionService,
    SpaceRepository,
    TuyaWebSocketService,
    OneSignalService,
    DeviceMessagesService,
    DeviceNotificationRepository,
    CommunityRepository,
    SosHandlerService,
  ],
  exports: [
    HelperHashService,
    SpacePermissionService,
    CommunityPermissionService,
  ],
  controllers: [],
  imports: [
    SpaceRepositoryModule,
    DeviceRepositoryModule,
    DeviceStatusFirebaseModule,
  ],
})
export class HelperModule {}
