import { IsArray, IsNotEmpty, IsString, ValidateNested } from 'class-validator';
import { Type } from 'class-transformer';
import { ProductDto } from '../../product/dtos';
import { NewTagDto } from '../../tag/dtos';
import { SubspaceDto } from './subspace.dto';

export class SubspaceProductAllocationDto {
  @IsString()
  @IsNotEmpty()
  public uuid: string;

  @ValidateNested()
  @Type(() => SubspaceDto)
  public subspace: SubspaceDto;

  @ValidateNested()
  @Type(() => ProductDto)
  product: ProductDto;

  @IsArray()
  @ValidateNested({ each: true })
  @Type(() => NewTagDto)
  tags: NewTagDto[];
}
