WITH params AS (
    SELECT 
        TO_DATE(NULLIF($1, ''), 'DD-MM-YYYY') AS start_date,
        TO_DATE(NULLIF($2, ''), 'DD-MM-YYYY') AS end_date,
        string_to_array(NULLIF($3, ''), ',') AS device_ids 
)

SELECT TO_CHAR(A.date, 'MM-YYYY') AS month,
  SUM(A.energy_consumed_kW::numeric) AS total_energy_consumed_KW,
  SUM(A.energy_consumed_A::numeric) AS total_energy_consumed_A,
  SUM(A.energy_consumed_B::numeric) AS total_energy_consumed_B,
  SUM(A.energy_consumed_C::numeric) AS total_energy_consumed_C
FROM public."power-clamp-energy-consumed-daily" AS A
JOIN public.device AS B
  ON A.device_uuid::TEXT = B."uuid"::TEXT
JOIN params P ON TRUE
WHERE B."uuid"::TEXT = ANY(P.device_ids)
  AND (P.start_date IS NULL OR A.date >= P.start_date)
  AND (P.end_date IS NULL OR A.date <= P.end_date)
GROUP BY 1

