import { ApiProperty } from '@nestjs/swagger';
import { IsNotEmpty, IsString, IsUUID } from 'class-validator';

export class DeleteAutomationParamDto {
  @ApiProperty({
    description: 'UUID of the Space',
    example: 'd290f1ee-6c54-4b01-90e6-d701748f0851',
  })
  @IsUUID()
  spaceUuid: string;

  @ApiProperty({
    description: 'TuyaId of the automation',
    example: 'SfFi2Tbn09btes84',
  })
  @IsString()
  @IsNotEmpty()
  automationUuid: string;
}
