import { RoleType } from '@app/common/constants/role.type.enum';
import { ApiProperty } from '@nestjs/swagger';
import { IsEnum, IsIn, IsNotEmpty, IsString } from 'class-validator';

export class AddUserRoleDto {
  @ApiProperty({
    description: 'userUuid',
    required: true,
  })
  @IsString()
  @IsNotEmpty()
  public userUuid: string;

  @ApiProperty({
    description: 'Role type (ADMIN)',
    enum: [RoleType.ADMIN],
    required: true,
  })
  @IsEnum(RoleType)
  @IsIn([RoleType.ADMIN], {
    message: 'roleType must be one of the following values:  ADMIN',
  })
  roleType: RoleType;
}
