import { SpaceProductAllocationRepository } from '@app/common/modules/space';
import { SubspaceModelProductAllocationRepoitory } from '@app/common/modules/space-model';
import {
  SubspaceProductAllocationRepository,
  SubspaceRepository,
} from '@app/common/modules/space/repositories/subspace.repository';
import { CommandHandler, ICommandHandler } from '@nestjs/cqrs';
import { PropogateUpdateSpaceModelProductAllocationCommand } from '../commands';

@CommandHandler(PropogateUpdateSpaceModelProductAllocationCommand)
export class PropogateUpdateSpaceModelProductAllocationHandler
  implements ICommandHandler<PropogateUpdateSpaceModelProductAllocationCommand>
{
  constructor(
    private readonly subspaceRepository: SubspaceRepository,
    private readonly subspaceModelProductRepository: SubspaceModelProductAllocationRepoitory,
    private readonly subspaceProductRepository: SubspaceProductAllocationRepository,
    private readonly spaceProductRepository: SpaceProductAllocationRepository,
  ) {}

  async execute(
    command: PropogateUpdateSpaceModelProductAllocationCommand,
  ): Promise<void> {
    const { spaces, updatedAllocations } = command.param;

    try {
      if (!updatedAllocations || updatedAllocations.length === 0) {
        console.log('No updated allocations found. Exiting execution.');
        return;
      }

      console.log(`Processing ${updatedAllocations.length} allocations...`);

      // for (const allocation of updatedAllocations) {
      //   try {
      //     if (allocation.allocation) {
      //       const spaceAllocations = await this.spaceProductRepository.find({
      //         where: { uuid: allocation.allocation.uuid },
      //         relations: ['tags'],
      //       });

      //       if (!spaceAllocations || spaceAllocations.length === 0) {
      //         console.warn(
      //           `No space allocations found for UUID: ${allocation.allocation.uuid}`,
      //         );
      //         continue;
      //       }

      //       if (allocation.tagsAdded?.length) {
      //         for (const spaceAllocation of spaceAllocations) {
      //           spaceAllocation.tags.push(...allocation.tagsAdded);
      //         }
      //         await this.spaceProductRepository.save(spaceAllocations);
      //         console.log(
      //           `Added tags to ${spaceAllocations.length} space allocations.`,
      //         );
      //       }

      //       if (allocation.tagsRemoved?.length) {
      //         const tagsToRemoveUUIDs = new Set(
      //           allocation.tagsRemoved.map((tag) => tag.uuid),
      //         );

      //         for (const spaceAllocation of spaceAllocations) {
      //           spaceAllocation.tags = spaceAllocation.tags.filter(
      //             (tag) => !tagsToRemoveUUIDs.has(tag.uuid),
      //           );
      //         }
      //         await this.spaceProductRepository.save(spaceAllocations);
      //         console.log(
      //           `Removed tags from ${spaceAllocations.length} space allocations.`,
      //         );
      //       }
      //     }

      //     if (allocation.deletedAllocation) {
      //       const spaceAllocations = await this.spaceProductRepository.find({
      //         where: { uuid: allocation.deletedAllocation.uuid },
      //         relations: ['tags'],
      //       });

      //       if (!spaceAllocations || spaceAllocations.length === 0) {
      //         console.warn(
      //           `No space allocations found to delete for UUID: ${allocation.deletedAllocation.uuid}`,
      //         );
      //         continue;
      //       }

      //       await this.spaceProductRepository.remove(spaceAllocations);
      //       console.log(
      //         `Deleted ${spaceAllocations.length} space allocations.`,
      //       );
      //     }

      //     if (allocation.newAllocation) {
      //       const newAllocations = spaces.map((space) =>
      //         this.spaceProductRepository.create({
      //           space,
      //           product: allocation.newAllocation.product,
      //           tag: allocation.newAllocation.tag,
      //           inheritedFromModel: allocation.newAllocation,
      //         }),
      //       );

      //       await this.spaceProductRepository.save(newAllocations);
      //       console.log(
      //         `Created ${newAllocations.length} new space allocations.`,
      //       );
      //     }
      //   } catch (error) {
      //     console.error(
      //       `Error processing allocation update: ${JSON.stringify(allocation)}`,
      //       error,
      //     );
      //   }
      // }

      console.log('Finished processing all allocations.');
    } catch (error) {
      console.error('Unexpected error during execute method:', error);
    }
  }
}
