import { ApiProperty } from '@nestjs/swagger';
import { IsUUID } from 'class-validator';
import { GetSpaceParam } from './get.space.param';

export class UserSpaceParam extends GetSpaceParam {
  @ApiProperty({
    description: 'Uuid of the user to be associated/ dissociated',
    example: 'd290f1ee-6c54-4b01-90e6-d701748f0851',
  })
  @IsUUID()
  userUuid: string;
}
